

//-------------------------------------------------------------------
class particle {
  
  Vec2D pos;
  Vec2D vel;
  Vec2D frc;   // frc is also know as acceleration (newton says "f=ma")
  
  //--------------------------
  // contructor:
  particle(){
    pos = new Vec2D(0,0);
    vel = new Vec2D(0,0);
    frc = new Vec2D(0,0);
  }
  
  //--------------------------
  void resetForce(){
      // we reset the forces every frame
      frc.set(0,0);
  }
  
  //--------------------------
  void setInitialCondition(float px, float py, float vx, float vy){
    pos.x = px;
    pos.y = py;
    vel.x = vx;
    vel.y = vy;
  }
  
  //--------------------------
  void addForce(float x, float y){
    // add in a force in X and Y for this frame. 
    frc.x = frc.x + x;
    frc.y = frc.y + y;
  }
  
  //--------------------------
  void addDampingForce(){
      float damping = 0.09;
      frc.x = frc.x - vel.x * damping;
      frc.y = frc.y - vel.y * damping;
  }
  
  //--------------------------
  void update(){
    vel.x = vel.x + frc.x;
    vel.y = vel.y + frc.y;
    pos.x = pos.x + vel.x;
    pos.y = pos.y + vel.y;
  }

  
  //--------------------------
  void draw(){ 
     noStroke();
     fill(0); 
     ellipse(pos.x, pos.y, 5,5);
  } 
  
}
