// I am a field the particles will move on!

//------------
class vectorField {
  
  int FIELD_SIZE;
  int WIDTH_FIELD         = 40;
  int HEIGHT_FIELD        = 20;
  Vec2D []  field;
  
  
  //------------
  vectorField(){
  
    FIELD_SIZE = WIDTH_FIELD * HEIGHT_FIELD;
    field = new Vec2D[FIELD_SIZE];
    for (int i = 0; i < FIELD_SIZE; i++){
      field[i] = new Vec2D(0,0);
    }
  }
  
  //------------
  void clear(){
    for (int i = 0; i < FIELD_SIZE; i++){
      field[i].set(0,0);
    }
  }
  
  //------------
  void fadeField(float fadeAmount){
     for (int i = 0; i < FIELD_SIZE; i++){
      field[i].mult(fadeAmount);
    }
  }
  
  //------------
  void randomizeField(float scale){
    for (int i = 0; i < FIELD_SIZE; i++){
      // random between -1 and 1 ---- (Math.random()*2.0f-1.0f) 
      float x = (float)(Math.random()*2.0f-1.0f) * scale;
      float y = (float)(Math.random()*2.0f-1.0f) * scale;
      field[i].set(x,y);
    } 
  }
  
  void draw(float width, float height){
    
    float scalex = width / (float)WIDTH_FIELD;
    float scaley = height / (float)HEIGHT_FIELD;
    
    for (int i = 0; i < WIDTH_FIELD; i++){
      for (int j = 0; j < HEIGHT_FIELD; j++){
      
        // pos in array
        int pos = j * WIDTH_FIELD + i;
        // pos on screen
        float px = 	i * scalex;
        float py = 	j * scaley;
        float px2 = 	px + field[pos].x * 5;
        float py2 = 	py + field[pos].y * 5;
        
        stroke(255);
        line(px,py, px2, py2);
     }
   }
 }
 
  void getVelFromPos(float xpos, float ypos, Vec2D v){
    
    // where are we in the array
    int fieldPosX = (int)(xpos * (float)WIDTH_FIELD);
    int fieldPosY = (int)(ypos * (float)HEIGHT_FIELD);
    
    // saftey	
    fieldPosX = Math.max(0, Math.min(fieldPosX, WIDTH_FIELD-1));
    fieldPosY = Math.max(0, Math.min(fieldPosY, HEIGHT_FIELD-1));
    
    // pos in array
    int pos = fieldPosY * WIDTH_FIELD + fieldPosX;
    
    v.set(field[pos].x * 0.1, field[pos].y * 0.1 );
  }
  
  
  
  //-------------
  void addToFieldAnInwardCircleShape(float x, float y, float radius, float strength){
  	
    int fieldPosX = (int)(x * (float)WIDTH_FIELD);
    int fieldPosY = (int)(y * (float)HEIGHT_FIELD);
	
    for (int i = 0; i < WIDTH_FIELD; i++){
      for (int j = 0; j < HEIGHT_FIELD; j++){
        int pos = j * WIDTH_FIELD + i;			
        float distance = (float)Math.sqrt((fieldPosX-i)*(fieldPosX-i) + 
		                 (fieldPosY-j)*(fieldPosY-j));
        if (distance < radius && distance > 0){
          float pct = 1.0f - (distance / radius);
          float strongness = strength * pct;
          float unit_px = ( fieldPosX - i) / distance;
          float unit_py = ( fieldPosY - j) / distance;
          field[pos].x += unit_px * strongness;
          field[pos].y += unit_py * strongness;
          //make a unit vector between origin and pt
        }
      }	
    }
  }
  
  
  //-------------
  void addToFieldAnOutwardCircleShape(float x, float y, float radius, float strength){
  	
    int fieldPosX = (int)(x * (float)WIDTH_FIELD);
    int fieldPosY = (int)(y * (float)HEIGHT_FIELD);
	
    for (int i = 0; i < WIDTH_FIELD; i++){
      for (int j = 0; j < HEIGHT_FIELD; j++){
        int pos = j * WIDTH_FIELD + i;			
        float distance = (float)Math.sqrt((fieldPosX-i)*(fieldPosX-i) + 
		                 (fieldPosY-j)*(fieldPosY-j));
        if (distance < radius && distance > 0){
          float pct = 1.0f - (distance / radius);
          float strongness = strength * pct;
          float unit_px = ( fieldPosX - i) / distance;
          float unit_py = ( fieldPosY - j) / distance;
          field[pos].x -= unit_px * strongness;
          field[pos].y -= unit_py * strongness;
          //make a unit vector between origin and pt
        }
      }	
    }
  }
  
  
  
  //-------------
  void addToFieldAnClockwiseCircleShape(float x, float y, float radius, float strength){
  	
    int fieldPosX = (int)(x * (float)WIDTH_FIELD);
    int fieldPosY = (int)(y * (float)HEIGHT_FIELD);
	
    for (int i = 0; i < WIDTH_FIELD; i++){
      for (int j = 0; j < HEIGHT_FIELD; j++){
        int pos = j * WIDTH_FIELD + i;			
        float distance = (float)Math.sqrt((fieldPosX-i)*(fieldPosX-i) + 
		                 (fieldPosY-j)*(fieldPosY-j));
        if (distance < radius && distance > 0){
          float pct = 1.0f - (distance / radius);
          float strongness = strength * pct;
          float unit_px = ( fieldPosX - i) / distance;
          float unit_py = ( fieldPosY - j) / distance;
          field[pos].x -= unit_py * strongness;
          field[pos].y += unit_px * strongness;
          //make a unit vector between origin and pt
        }
      }	
    }
  }
  
  
  
  
  //-------------
  void addToFieldAnCounterClockwiseCircleShape(float x, float y, float radius, float strength){
  	
    int fieldPosX = (int)(x * (float)WIDTH_FIELD);
    int fieldPosY = (int)(y * (float)HEIGHT_FIELD);
	
    for (int i = 0; i < WIDTH_FIELD; i++){
      for (int j = 0; j < HEIGHT_FIELD; j++){
        int pos = j * WIDTH_FIELD + i;			
        float distance = (float)Math.sqrt((fieldPosX-i)*(fieldPosX-i) + 
		                 (fieldPosY-j)*(fieldPosY-j));
        if (distance < radius && distance > 0){
          float pct = 1.0f - (distance / radius);
          float strongness = strength * pct;
          float unit_px = ( fieldPosX - i) / distance;
          float unit_py = ( fieldPosY - j) / distance;
          field[pos].x += unit_py * strongness;
          field[pos].y -= unit_px * strongness;
          //make a unit vector between origin and pt
        }
      }	
    }
  }
  
  
  //-------------
  void addToFieldASpecialCircleShape(float x, float y, float vx, float vy, float radius, float strength){
  	
    int fieldPosX = (int)(x * (float)WIDTH_FIELD);
    int fieldPosY = (int)(y * (float)HEIGHT_FIELD);
	
    for (int i = 0; i < WIDTH_FIELD; i++){
      for (int j = 0; j < HEIGHT_FIELD; j++){
        int pos = j * WIDTH_FIELD + i;			
        float distance = (float)Math.sqrt((fieldPosX-i)*(fieldPosX-i) + 
		                 (fieldPosY-j)*(fieldPosY-j));
        if (distance < radius && distance > 0){
          float pct = 1.0f - (distance / radius);
          float strongness = strength * pct;
          float unit_px = ( fieldPosX - i) / distance;
          float unit_py = ( fieldPosY - j) / distance;
          field[pos].x += vx * strongness;
          field[pos].y += vy * strongness;
          //make a unit vector between origin and pt
        }
      }	
    }
  }
 
 
 
}
