

//-------------------------------------------------------------------
class particle {
  
  Vec2D pos;
  Vec2D vel;
  Vec2D frc;   // frc is also know as acceleration (newton says "f=ma")
  
  //--------------------------
  // contructor:
  particle(){
    pos = new Vec2D(0,0);
    vel = new Vec2D(0,0);
    frc = new Vec2D(0,0);
  }
  
  //--------------------------
  void resetForce(){
      // we reset the forces every frame
      frc.set(0,0);
  }
  
  //--------------------------
  void setInitialCondition(float px, float py, float vx, float vy){
    pos.x = px;
    pos.y = py;
    vel.x = vx;
    vel.y = vy;
  }
  
  
  void addRepulsionForce(particle p, float radius, float scale){
      float x = p.pos.x;
      float y = p.pos.y;
      boolean bAmCloseEnough = true;
      if (radius > 0){
        if (sqrt((x-pos.x)*(x-pos.x) + (y-pos.y)*(y-pos.y)) > radius){
          bAmCloseEnough = false;
        }
      } 
      
      if (bAmCloseEnough == true){
       Vec2D forceVec = new Vec2D(0,0); 
       forceVec.x = x-pos.x;
       forceVec.y = y-pos.y;
       forceVec.normalize();
       frc.x = frc.x - forceVec.x * scale;
       frc.y = frc.y - forceVec.y * scale;
       p.frc.x = p.frc.x + forceVec.x * scale;
       p.frc.y = p.frc.y + forceVec.y * scale;
     }
  }
  
  
  void addAttractionForce(particle p, float radius, float scale){
      float x = p.pos.x;
      float y = p.pos.y;
      boolean bAmCloseEnough = true;
      if (radius > 0){
        if (sqrt((x-pos.x)*(x-pos.x) + (y-pos.y)*(y-pos.y)) > radius){
          bAmCloseEnough = false;
        }
      } 
      
      if (bAmCloseEnough == true){
       Vec2D forceVec = new Vec2D(0,0); 
       forceVec.x = x-pos.x;
       forceVec.y = y-pos.y;
       forceVec.normalize();
       frc.x = frc.x + forceVec.x * scale;
       frc.y = frc.y + forceVec.y * scale;
       p.frc.x = p.frc.x - forceVec.x * scale;
       p.frc.y = p.frc.y - forceVec.y * scale;
     }
  }
  
  void addRepulsionForce(float x, float y, float radius, float scale){
      boolean bAmCloseEnough = true;
      if (radius > 0){
        if (sqrt((x-pos.x)*(x-pos.x) + (y-pos.y)*(y-pos.y)) > radius){
          bAmCloseEnough = false;
        }
      } 
      
      if (bAmCloseEnough == true){
       Vec2D forceVec = new Vec2D(0,0); 
       forceVec.x = x-pos.x;
       forceVec.y = y-pos.y;
       forceVec.normalize();
       frc.x = frc.x - forceVec.x * scale;
       frc.y = frc.y - forceVec.y * scale;
     }
  }
  
  void addAttractionForce(float x, float y, float radius, float scale){
      
      boolean bAmCloseEnough = true;
      if (radius > 0){
        if (sqrt((x-pos.x)*(x-pos.x) + (y-pos.y)*(y-pos.y)) > radius){
          bAmCloseEnough = false;
        }
      } 
      
      if (bAmCloseEnough == true){
       Vec2D forceVec = new Vec2D(0,0); 
       forceVec.x = x-pos.x;
       forceVec.y = y-pos.y;
       forceVec.normalize();
       frc.x = frc.x + forceVec.x * scale;
       frc.y = frc.y + forceVec.y * scale;
     }
  }
  
  //--------------------------
  void addForce(float x, float y){
    // add in a force in X and Y for this frame. 
    frc.x = frc.x + x;
    frc.y = frc.y + y;
  }
  
  //--------------------------
  void addDampingForce(){
      float damping = 0.05;
      frc.x = frc.x - vel.x * damping;
      frc.y = frc.y - vel.y * damping;
  }
  
  //--------------------------
  void update(){
    vel.x = vel.x + frc.x;
    vel.y = vel.y + frc.y;
    pos.x = pos.x + vel.x;
    pos.y = pos.y + vel.y;
  }

  
  //--------------------------
  void draw(){ 
     noStroke();
     fill(198,246,55); 
     ellipse(pos.x, pos.y, 15,15);
  } 
  
}
