
// day_3_05: springs_3
// zach lieberman - thesystemis.com / zlieb@parsons.edu
// ----------------------------------------------------
// now, we will add some new force functions into the particle class



particle myParticles[];
ArrayList mySprings;

//-------------------------------------------------------------------
void setup() {
  size(400, 200);

  myParticles = new particle[20];
  mySprings = new ArrayList();

  float radius = 50;
  float xorig = 100;
  float yorig = 100;
  for (int i = 0; i < 20; i++) {
    myParticles[i] = new particle();
    float angle = (i / 19.0f) * TWO_PI;
    float x = xorig + radius * cos(angle);
    float y = yorig + radius * sin(angle);
    myParticles[i].pos.set(x, y);
    myParticles[i].vel.set(0, 0);
  }

  for (int i = 0; i < 20; i++) {
    // now, calculate the distance:
    int pta = i;
    int ptb = (i+1) % 20;
    Vec2D diff = new Vec2D(0, 0);
    diff.x = myParticles[pta].pos.x - myParticles[ptb].pos.x;
    diff.y = myParticles[pta].pos.y - myParticles[ptb].pos.y;
    float len = diff.length();
    spring s =  new spring(myParticles[pta], myParticles[ptb], len, 0.4);
    mySprings.add(s);
  }
}

//-------------------------------------------------------------------
void draw() {

  background(245, 17, 230);

  for (int i = 0; i < 20; i++) {
    myParticles[i].resetForce();
  }

  for (int i = 0; i < mySprings.size(); i++) {
    spring s = (spring)mySprings.get(i);
    s.calculateForcesOnParticles();
  }




  for (int i = 0; i < 20; i++) {
    myParticles[i].addDampingForce();
    myParticles[i].update();

    // then draw:
    myParticles[i].draw();
  }

  for (int i = 0; i < mySprings.size(); i++) {
    spring s = (spring)mySprings.get(i);
    s.draw();
  }
}


void mousePressed() {
  myParticles[0].bFixed = true;
}

void mouseReleased() {
  myParticles[0].bFixed = false;
}
void mouseDragged() {
  myParticles[0].pos.set(mouseX, mouseY);
}



